
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Spark Streaming Programming Guide / iVAN</title>

    <meta name="description" content="Spark Streaming Programming Guide 参考,http://spark.incubator.apache.org/docs/latest/streaming-programming-guide.html  Overview SparkStreaming支持多种流输入,like Kafka, Flume, Twitter, ZeroMQ or plain old TCP sockets,并且可以在上面进行transform操作,最终数据存入HDFS,数据库或dashboard 另外可以把Spark's in-built machine">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Spark Streaming Programming Guide</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>参考，<a href="http://spark.incubator.apache.org/docs/latest/streaming-programming-guide.html" rel="external nofollow noreferrer">http://spark.incubator.apache.org/docs/latest/streaming-programming-guide.html</a> </p>
<h4>Overview</h4>
<p><u>SparkStreaming支持多种流输入，like Kafka, Flume, Twitter, ZeroMQ or plain old TCP sockets，并且可以在上面进行transform操作，最终数据存入HDFS，数据库或dashboard<br />
另外可以把Spark’s in-built </u><a href="http://spark.incubator.apache.org/docs/latest/mllib-guide.html" rel="external nofollow noreferrer">machine learning</a><u> algorithms, and </u><a href="http://spark.incubator.apache.org/docs/latest/graphx-programming-guide.html" rel="external nofollow noreferrer">graph processing</a><u> algorithms用于spark streaming，这个比较有意思<br /><u>SparkStreaming</u>的原理，下面那幅图很清晰，将stream数据离散化，提出的概念<em>DStream</em>，其实就是sequence of <a href="http://spark.incubator.apache.org/docs/latest/api/core/index.html#org.apache.spark.rdd.RDD" rel="external nofollow noreferrer">RDDs</a></u></p>
<p>Spark Streaming is an extension of the core Spark API that allows enables high-throughput, fault-tolerant stream processing of live data streams. <br />
Data can be ingested from many sources like Kafka, Flume, Twitter, ZeroMQ or plain old TCP sockets and be processed using complex algorithms expressed with high-level functions like <code>map</code>, <code>reduce</code>, <code>join</code> and <code>window</code>. Finally, processed data can be pushed out to filesystems, databases, and live dashboards. In fact, you can apply Spark’s in-built <a href="http://spark.incubator.apache.org/docs/latest/mllib-guide.html" rel="external nofollow noreferrer">machine learning</a>algorithms, and <a href="http://spark.incubator.apache.org/docs/latest/graphx-programming-guide.html" rel="external nofollow noreferrer">graph processing</a> algorithms on data streams.</p>
<p><a href="http://images.cnitblog.com/blog/312753/201402/211818367736124.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDE0MDIvMjExODE4MzczNDI5Njk3LnBuZw==.jpg"></a></p>
<p>Internally, it works as follows. Spark Streaming receives live input data streams and divides the data into batches, which are then processed by the Spark engine to generate the final stream of results in batches.</p>
<p><a href="http://images.cnitblog.com/blog/312753/201402/211818376328254.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDE0MDIvMjExODE4Mzc4OTQyNzk4LnBuZw==.jpg"></a></p>
<p>Spark Streaming provides a high-level abstraction called <em>discretized stream</em> or <em>DStream</em>, which represents a continuous stream of data. DStreams can be created either from input data stream from sources such as Kafka and Flume, or by applying high-level operations on other DStreams. Internally, a DStream is represented as a sequence of <a href="http://spark.incubator.apache.org/docs/latest/api/core/index.html#org.apache.spark.rdd.RDD" rel="external nofollow noreferrer">RDDs</a>.</p>
<h4>A Quick Example</h4>
<p>Before we go into the details of how to write your own Spark Streaming program, let’s take a quick look at what a simple Spark Streaming program looks like.</p>
<pre></pre>
<h4>Initializing</h4>
<p><u>StreamingContext是SparkStreaming的入口，就像SparkContext对于spark一样<br />
其实StreamingContext就是SparkContext的封装，通过<code>streamingContext.sparkContext</code>可以取得<br />
参数除了batchDuration，其他的都和SparkContext没有区别</u></p>
<p>To initialize a Spark Streaming program in Scala, a <a href="http://spark.incubator.apache.org/docs/latest/api/streaming/index.html#org.apache.spark.streaming.StreamingContext" rel="external nofollow noreferrer"><code>StreamingContext</code></a> object has to be created, which is the main entry point of all Spark Streaming functionality. <br />
A <code>StreamingContext</code> object can be created by using</p>
<pre></pre>
<p>The <code>master</code> parameter is a standard <a href="http://spark.incubator.apache.org/docs/latest/scala-programming-guide.html#master-urls" rel="external nofollow noreferrer">Spark cluster URL</a> and can be “local” for local testing. <br />
The <code>appName</code> is a name of your program, which will be shown on your cluster’s web UI. <br />
The <code>batchInterval</code> is the size of the batches, as explained earlier. <br />
Finally, the last two parameters are needed to deploy your code to a cluster if running in distributed mode, as described in the <a href="http://spark.incubator.apache.org/docs/latest/scala-programming-guide.html#deploying-code-on-a-cluster" rel="external nofollow noreferrer">Spark programming guide</a>. <br />
Additionally, the underlying SparkContext can be accessed as <code>streamingContext.sparkContext</code>.</p>
<p>The batch interval must be set based on the latency requirements of your application and available cluster resources. See the <a href="http://spark.incubator.apache.org/docs/latest/streaming-programming-guide.html#setting-the-right-batch-size" rel="external nofollow noreferrer">Performance Tuning</a> section for more details.</p>
<h4>DStreams</h4>
<p><u>通过图示很清晰的说明什么是DStream，和基于DStream的transform是怎样的？</u></p>
<p><em>Discretized Stream</em> or <em>DStream</em> is the basic abstraction provided by Spark Streaming. It represents a continuous stream of data, either the input data stream received from source, or the processed data stream generated by transforming the input stream. Internally, it is represented by a continuous sequence of RDDs, which is Spark’s abstraction of an immutable, distributed dataset. Each RDD in a DStream contains data from a certain interval, as shown in the following figure.</p>
<p><a href="http://images.cnitblog.com/blog/312753/201402/211818381583111.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDE0MDIvMjExODE4Mzg0MDQ2NjU0LnBuZw==.jpg"></a></p>
<p>Any operation applied on a DStream translates to operations on the underlying RDDs. For example, in the <a href="http://spark.incubator.apache.org/docs/latest/streaming-programming-guide.html#a-quick-example" rel="external nofollow noreferrer">earlier example</a> of converting a stream of lines to words, the <code>flatmap</code> operation is applied on each RDD in the <code>lines</code> DStream to generate the RDDs of the <code>words</code> DStream. This is shown the following figure.</p>
<p><a href="http://images.cnitblog.com/blog/312753/201402/211818386009412.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDE0MDIvMjExODE4Mzg4NjQ5NzI2LnBuZw==.jpg"></a></p>
<p>These underlying RDD transformations are computed by the Spark engine. The DStream operations hide most of these details and provides the developer with higher-level API for convenience. These operations are discussed in detail in later sections.</p>
<h4>Operations</h4>
<p><u>DStream支持<em>transformations</em> and <em>output</em>，和Spark的action不太一样</u></p>
<p>There are two kinds of DStream operations - <em>transformations</em> and <em>output operations</em>. <br />
Similar to RDD transformations, DStream transformations operate on one or more DStreams to create new DStreams with transformed data.<br />
After applying a sequence of transformations to the input streams, output operations need to called, which write data out to an external data sink, such as a filesystem or a database.</p>
<p><u>Transformations大部分都和RDD中的一样，参考原文，重点说下底下的几个，</u></p>
<p><u>UpdateStateByKey Operation</u></p>
<p><u>用流数据持续更新state，比如下面的例子，wordcount<br />
只需要定义updateFunction，如何根据newValue更新现有的state</u></p>
<p>The <code>updateStateByKey</code> operation allows you to maintain arbitrary stateful computation, where you want to maintain some state data and continuously update it with new information. <br />
To use this, you will have to do two steps.</p>
<ol>
<li>Define the state - The state can be of arbitrary data type.</li>
<li>Define the state update function - Specify with a function how to update the state using the previous state and the new values from input stream.</li>
</ol>
<p>Let’s illustrate this with an example. Say you want to maintain a running count of each word seen in a text data stream. Here, the running count is the state and it is an integer. We define the update function as</p>
<pre></pre>
<p><u>Transform Operation</u></p>
<p><u>Transform可以在DStream上apply任意的RDD操作，尤其有意思的是，可以通过Transform使用Spark的MLlib和Graph算法</u></p>
<p>The <code>transform</code> operation (along with its variations like <code>transformWith</code>) allows arbitrary RDD-to-RDD functions to be applied on a DStream. It can be used to apply any RDD operation that is not exposed in the DStream API. For example, the functionality of joining every batch in a data stream with another dataset is not directly exposed in the DStream API. However, you can easily use <code>transform</code> to do this. This enables very powerful possibilities. For example, if you want to do real-time data cleaning by joining the input data stream with precomputed spam information (maybe generated with Spark as well) and then filtering based on it.</p>
<pre></pre>
<p>In fact, you can also use <a href="http://spark.incubator.apache.org/docs/latest/mllib-guide.html" rel="external nofollow noreferrer">machine learning</a> and <a href="http://spark.incubator.apache.org/docs/latest/graphx-programming-guide.html" rel="external nofollow noreferrer">graph computation</a> algorithms in the <code>transform</code> method.</p>
<p><u>Window Operations</u></p>
<p><u>作为streaming处理，当然需要支持典型的slide-windows based的方法<br />
可以看下面的图，可以将original中的slide-windows上的多个RDDs生成windowed DStream上的单个RDD<br />
两个重要的参数，windows length和slide inteval，下面的图中分别是3和2</u></p>
<p>Finally, Spark Streaming also provides <em>windowed computations</em>, which allow you to apply transformations over a sliding window of data. This following figure illustrates this sliding window.</p>
<p><a href="http://images.cnitblog.com/blog/312753/201402/222213478203349.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDE0MDIvMjIyMjEzNTMxNDEyMjM5LnBuZw==.jpg"></a></p>
<p>As shown in the figure, every time the window <em>slides</em> over a source DStream, the source RDDs that fall within the window are combined and operated upon to produce the RDDs of the windowed DStream. In this specific case, the operation is applied over last 3 time units of data, and slides by 2 time units. This shows that any window-based operation needs to specify two parameters.</p>
<ul>
<li><i>window length</i> - The duration of the window (3 in the figure)</li>
<li><i>slide interval</i> - The interval at which the window-based operation is performed (2 in the figure).</li>
</ul>
<p>These two parameters must be multiples of the batch interval of the source DStream (1 in the figure).</p>
<p><u>给个例子，统计过去30秒的word count，每次递进10秒</u></p>
<p>Let’s illustrate the window operations with an example. Say, you want to extend the <a href="http://spark.incubator.apache.org/docs/latest/streaming-programming-guide.html#a-quick-example" rel="external nofollow noreferrer">earlier example</a> by generating word counts over last 30 seconds of data, every 10 seconds. To do this, we have to apply the <code>reduceByKey</code> operation on the<code>pairs</code> DStream of <code>(word, 1)</code> pairs over the last 30 seconds of data. This is done using the operation <code>reduceByKeyAndWindow</code>.</p>
<pre>// Reduce last 30 seconds of data, every 10 seconds
val windowedWordCounts = pairs.reduceByKeyAndWindow(_ + _, Seconds(30), Seconds(10))</pre>
<p>Some of the common window-based operations are as follows. All of these operations take the said two parameters -<i>windowLength</i> and <i>slideInterval</i>.<br /><a href="http://images.cnitblog.com/blog/312753/201402/222213599651159.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDE0MDIvMjIyMjE0MTA3ODExMjk1LnBuZw==.jpg"></a></p>
<p><u>Output Operations</u></p>
<p>When an output operator is called, it triggers the computation of a stream. Currently the following output operators are defined:</p>
<p><a href="http://images.cnitblog.com/blog/312753/201402/222214153882570.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDE0MDIvMjIyMjE0MTk2NjMyMzQzLnBuZw==.jpg"></a></p>
<h4>Persistence</h4>
<p><u>DStream的persistence是通过persist之上的每个RDD来实现的，并没有什么特别的地方<br />
需要注意的是，window-based operations会自动将persist设为true，因为slide-windows based算法中，每个RDD都会被读多遍<br />
而且对于来自Kafka, Flume, sockets, etc.的数据，default的persist策略是，产生2个replicas并同时写入两个节点，便于fault-tolerance<br />
Spark的fault-tolerance取决于replay，对于普通的Spark数据是从文件读的，所以replay只是重新读取数据而已，很简单<br />
但对于流数据，数据一旦流过就无法replay，所以SparkStreaming必须在source采取2-replicas的策略</u></p>
<p>Similar to RDDs, DStreams also allow developers to persist the stream’s data in memory. That is, using <code>persist()</code> method on a DStream would automatically persist every RDD of that DStream in memory. This is useful if the data in the DStream will be computed multiple times (e.g., multiple operations on the same data). For window-based operations like <code>reduceByWindow</code> and<code>reduceByKeyAndWindow</code> and state-based operations like <code>updateStateByKey</code>, this is implicitly true. Hence, DStreams generated by window-based operations are automatically persisted in memory, without the developer calling <code>persist()</code>.</p>
<p>For input streams that receive data over the network (such as, Kafka, Flume, sockets, etc.), the default persistence level is set to replicate the data to two nodes for fault-tolerance.</p>
<p>Note that, unlike RDDs, the default persistence level of DStreams keeps the data serialized in memory. This is further discussed in the <a href="http://spark.incubator.apache.org/docs/latest/streaming-programming-guide.html#memory-tuning" rel="external nofollow noreferrer">Performance Tuning</a> section. More information on different persistence levels can be found in <a href="http://spark.incubator.apache.org/docs/latest/scala-programming-guide.html#rdd-persistence" rel="external nofollow noreferrer">Spark Programming Guide</a>.</p>
<h4>RDD Checkpointing</h4>
<p><u>同样DStream也支持checkpoint，即把RDD写入HDFS中，当然cp会影响相应时间，所以要处理好这个balance，一般cp interval为5 - 10 times of sliding interval，至少10秒<br />
在DStream中cp主要用于stateful operation，比如前面说的wordcount，由于streaming处理的特点，即使persist，也只可能保留一段时间的数据，所以如果不去做cp，crash后是无法replay出太久以前的结果的，所以对于DStream而已CP的意义更为重要（对于spark，cp只是节省时间）</u></p>
<p>A <em>stateful operation</em> is one which operates over multiple batches of data. This includes all window-based operations and the<code>updateStateByKey</code> operation. Since stateful operations have a dependency on previous batches of data, they continuously accumulate metadata over time. To clear this metadata, streaming supports periodic <em>checkpointing</em> by saving intermediate data to HDFS. Note that checkpointing also incurs the cost of saving to HDFS which may cause the corresponding batch to take longer to process. Hence, the interval of checkpointing needs to be set carefully. At small batch sizes (say 1 second), checkpointing every batch may significantly reduce operation throughput. Conversely, checkpointing too slowly causes the lineage and task sizes to grow which may have detrimental effects. Typically, a checkpoint interval of 5 - 10 times of sliding interval of a DStream is good setting to try.</p>
<p>To enable checkpointing, the developer has to provide the HDFS path to which RDD will be saved. This is done by using</p>
<pre><code>ssc.checkpoint(hdfsPath) // assuming ssc is the StreamingContext or JavaStreamingContext
</code></pre>
<p>The interval of checkpointing of a DStream can be set by using</p>
<pre><code>dstream.checkpoint(checkpointInterval)
</code></pre>
<p>For DStreams that must be checkpointed (that is, DStreams created by <code>updateStateByKey</code> and <code>reduceByKeyAndWindow</code> with inverse function), the checkpoint interval of the DStream is by default set to a multiple of the DStream’s sliding interval such that its at least 10 seconds.</p>
<h4>Performance Tuning</h4>
<p><u>在性能优化上，主要考虑两点<br />
1. 如果降低每个batch的执行时间，增加并发度，减少不必要的serialization和降低task launch的overhead（减少tasksize和使用Standalone or coarse-grained Mesos mode ）<br />
2. 设置合适batch size，batch size越小肯定越接近流处理，但是overhead越大，所以需要balance，建议是先在一个比较保守的size和比较小的流量下进行测试，然后如果系统稳定，在逐步减少size和加大流量</u></p>
<p>Getting the best performance of a Spark Streaming application on a cluster requires a bit of tuning. This section explains a number of the parameters and configurations that can tuned to improve the performance of you application. At a high level, you need to consider two things:</p>
<ol>
<li>Reducing the processing time of each batch of data by efficiently using cluster resources.</li>
<li>Setting the right batch size such that the data processing can keep up with the data ingestion.</li>
</ol>
<p><u><strong>Reducing the Processing Time of each Batch</strong></u></p>
<p>There are a number of optimizations that can be done in Spark to minimize the processing time of each batch. These have been discussed in detail in <a href="http://spark.incubator.apache.org/docs/latest/tuning.html" rel="external nofollow noreferrer">Tuning Guide</a>. This section highlights some of the most important ones.</p>
<p><u>Level of Parallelism</u></p>
<p>Cluster resources maybe under-utilized if the number of parallel tasks used in any stage of the computation is not high enough. For example, for distributed reduce operations like <code>reduceByKey</code> and <code>reduceByKeyAndWindow</code>, the default number of parallel tasks is 8. You can pass the level of parallelism as an argument (see the <a href="http://spark.incubator.apache.org/docs/latest/api/streaming/index.html#org.apache.spark.streaming.dstream.PairDStreamFunctions" rel="external nofollow noreferrer"><code>PairDStreamFunctions</code></a> documentation), or set the <a href="http://spark.incubator.apache.org/docs/latest/configuration.html#spark-properties" rel="external nofollow noreferrer">config property</a> <code>spark.default.parallelism</code> to change the default.</p>
<p><u>Data Serialization</u></p>
<p>The overhead of data serialization can be significant, especially when sub-second batch sizes are to be achieved. There are two aspects to it.</p>
<ul>
<li><strong>Serialization of RDD data in Spark</strong>: Please refer to the detailed discussion on data serialization in the <a href="http://spark.incubator.apache.org/docs/latest/tuning.html" rel="external nofollow noreferrer">Tuning Guide</a>. However, note that unlike Spark, by default RDDs are persisted as serialized byte arrays to minimize pauses related to GC.</li>
<li><strong>Serialization of input data</strong>: To ingest external data into Spark, data received as bytes (say, from the network) needs to deserialized from bytes and re-serialized into Spark’s serialization format. Hence, the deserialization overhead of input data may be a bottleneck.</li>
</ul>
<p><u>Task Launching Overheads</u></p>
<p>If the number of tasks launched per second is high (say, 50 or more per second), then the overhead of sending out tasks to the slaves maybe significant and will make it hard to achieve sub-second latencies. The overhead can be reduced by the following changes:</p>
<ul>
<li><strong>Task Serialization</strong>: Using Kryo serialization for serializing tasks can reduced the task sizes, and therefore reduce the time taken to send them to the slaves.</li>
<li><strong>Execution mode</strong>: Running Spark in Standalone mode or coarse-grained Mesos mode leads to better task launch times than the fine-grained Mesos mode. Please refer to the <a href="http://spark.incubator.apache.org/docs/latest/running-on-mesos.html" rel="external nofollow noreferrer">Running on Mesos guide</a> for more details.</li>
</ul>
<p>These changes may reduce batch processing time by 100s of milliseconds, thus allowing sub-second batch size to be viable.</p>
<p><u><strong>Setting the Right Batch Size</strong></u></p>
<p>For a Spark Streaming application running on a cluster to be stable, the processing of the data streams must keep up with the rate of ingestion of the data streams. Depending on the type of computation, the batch size used may have significant impact on the rate of ingestion that can be sustained by the Spark Streaming application on a fixed cluster resources. For example, let us consider the earlier WordCountNetwork example. For a particular data rate, the system may be able to keep up with reporting word counts every 2 seconds (i.e., batch size of 2 seconds), but not every 500 milliseconds.</p>
<p>A good approach to figure out the right batch size for your application is to test it with a conservative batch size (say, 5-10 seconds) and a low data rate. To verify whether the system is able to keep up with data rate, you can check the value of the end-to-end delay experienced by each processed batch (either look for “Total delay” in Spark driver log4j logs, or use the <a href="http://spark.incubator.apache.org/docs/latest/api/streaming/index.html#org.apache.spark.streaming.scheduler.StreamingListener" rel="external nofollow noreferrer">StreamingListener</a> interface). If the delay is maintained to be comparable to the batch size, then system is stable. Otherwise, if the delay is continuously increasing, it means that the system is unable to keep up and it therefore unstable. Once you have an idea of a stable configuration, you can try increasing the data rate and/or reducing the batch size. Note that momentary increase in the delay due to temporary data rate increases maybe fine as long as the delay reduces back to a low value (i.e., less than batch size).</p>
<p><strong><u>24/7 Operation</u></strong></p>
<p><u>Streaming操作，数据是无限的，所以必然需要cleanup metadata，比如generated RDD<br />
可以在SparkContext创建前，通过<code>spark.cleaner.ttl</code> 设置cleanup时间<br />
注意cleanup时间必须要比任意window operation的窗口大小要长</u></p>
<p>By default, Spark does not forget any of the metadata (RDDs generated, stages processed, etc.). But for a Spark Streaming application to operate 24/7, it is necessary for Spark to do periodic cleanup of it metadata. This can be enabled by setting the <a href="http://spark.incubator.apache.org/docs/latest/configuration.html#spark-properties" rel="external nofollow noreferrer">configuration property</a> <code>spark.cleaner.ttl</code> to the number of seconds you want any metadata to persist. For example, setting <code>spark.cleaner.ttl</code> to 600 would cause Spark periodically cleanup all metadata and persisted RDDs that are older than 10 minutes. Note, that this property needs to be set before the SparkContext is created.</p>
<p>This value is closely tied with any window operation that is being used. Any window operation would require the input data to be persisted in memory for at least the duration of the window. Hence it is necessary to set the delay to at least the value of the largest window operation used in the Spark Streaming application. If this delay is set too low, the application will throw an exception saying so.</p>
<p><strong><u>Monitoring</u></strong></p>
<p>Besides Spark’s in-built <a href="http://spark.incubator.apache.org/docs/latest/monitoring.html" rel="external nofollow noreferrer">monitoring capabilities</a>, the progress of a Spark Streaming program can also be monitored using the [StreamingListener] (streaming/index.html#org.apache.spark.scheduler.StreamingListener) interface, which allows you to get statistics of batch processing times, queueing delays, and total end-to-end delays. Note that this is still an experimental API and it is likely to be improved upon (i.e., more information reported) in the future.</p>
<p><strong><u>Memory Tuning</u></strong></p>
<p>Tuning the memory usage and GC behavior of Spark applications have been discussed in great detail in the <a href="http://spark.incubator.apache.org/docs/latest/tuning.html" rel="external nofollow noreferrer">Tuning Guide</a>. It is recommended that you read that. In this section, we highlight a few customizations that are strongly recommended to minimize GC related pauses in Spark Streaming applications and achieving more consistent batch processing times.</p>
<ul>
<li><strong>Default persistence level of DStreams</strong>: Unlike RDDs, the default persistence level of DStreams serializes the data in memory (that is, <a href="http://spark.incubator.apache.org/docs/latest/api/core/index.html#org.apache.spark.storage.StorageLevel%24" rel="external nofollow noreferrer">StorageLevel.MEMORY_ONLY_SER</a> for DStream compared to <a href="http://spark.incubator.apache.org/docs/latest/api/core/index.html#org.apache.spark.storage.StorageLevel%24" rel="external nofollow noreferrer">StorageLevel.MEMORY_ONLY</a> for RDDs). Even though keeping the data serialized incurs higher serialization/deserialization overheads, it significantly reduces GC pauses.</li>
<li><strong>Clearing persistent RDDs</strong>: By default, all persistent RDDs generated by Spark Streaming will be cleared from memory based on Spark’s in-built policy (LRU). If <code>spark.cleaner.ttl</code> is set, then persistent RDDs that are older than that value are periodically cleared. As mentioned <a href="http://spark.incubator.apache.org/docs/latest/streaming-programming-guide.html#operation" rel="external nofollow noreferrer">earlier</a>, this needs to be careful set based on operations used in the Spark Streaming program. However, a smarter unpersisting of RDDs can be enabled by setting the <a href="http://spark.incubator.apache.org/docs/latest/configuration.html#spark-properties" rel="external nofollow noreferrer">configuration property</a><code>spark.streaming.unpersist</code> to <code>true</code>. This makes the system to figure out which RDDs are not necessary to be kept around and unpersists them. This is likely to reduce the RDD memory usage of Spark, potentially improving GC behavior as well.</li>
<li><strong>Concurrent garbage collector</strong>: Using the concurrent mark-and-sweep GC further minimizes the variability of GC pauses. Even though concurrent GC is known to reduce the overall processing throughput of the system, its use is still recommended to achieve more consistent batch processing times.</li>
</ul>
<h4>Fault-tolerance Properties</h4>
<p><u>简而言之，Spark的fault-tolerance是很容易做的，因为只有source data存在，任何RDD都是可以被replay出来的<br />
所以关键问题在于如何保证source data的fault-tolerance</u></p>
<p>In this section, we are going to discuss the behavior of Spark Streaming application in the event of a node failure. To understand this, let us remember the basic fault-tolerance properties of Spark’s RDDs.</p>
<ol>
<li>An RDD is an immutable, deterministically re-computable, distributed dataset. Each RDD remembers the lineage of deterministic operations that were used on a fault-tolerant input dataset to create it.</li>
<li>If any partition of an RDD is lost due to a worker node failure, then that partition can be re-computed from the original fault-tolerant dataset using the lineage of operations.</li>
</ol>
<p>Since all data transformations in Spark Streaming are based on RDD operations, as long as the input dataset is present, all intermediate data can recomputed. Keeping these properties in mind, we are going to discuss the failure semantics in more detail.</p>
<p><u><strong>Failure of a Worker Node</strong></u></p>
<p><u>对于worker node的失败，只需要换个worker把RDD给replay出来就可以了，前提就是要能够重新取到source data<br />
所以对于用HDFS作为input source的case，fault-tolerance是没有问题的<br />
关键是，以network作为input source的case（比如，kafka，flume，socket），如何保证能够重新读到source data？<br />
做法是首先以2-replicas把source data放到两个node的memory中，一个fail，可以用另一个replay<br />
但是一种情况下，还是会丢数据，就是当network receiver所在的node fail的时候，那么从network上读到并还没有来得及完成replicas的数据就会丢失</u></p>
<p><u>另外需要注意的是，对于RDD的transform是可以保证<em>exactly-once</em> semantics的，但是对于output operations就只能保证<em>at-least once</em>semantics<br />
比如，某个RDD已经部分被写到file中，这个时候fail，当worker replay出RDD的时候会重新写一遍<br />
所以如果要保证<em>exactly-once</em>，必须自己加上additional transactions-like mechanisms</u></p>
<p>There are two failure behaviors based on which input sources are used.</p>
<ol>
<li><em>Using HDFS files as input source</em> - Since the data is reliably stored on HDFS, all data can re-computed and therefore no data will be lost due to any failure.</li>
<li><em>Using any input source that receives data through a network</em> - For network-based data sources like Kafka and Flume, the received input data is replicated in memory between nodes of the cluster (default replication factor is 2). So if a worker node fails, then the system can recompute the lost from the the left over copy of the input data. However, if the worker node where a network receiver was running fails, then a tiny bit of data may be lost, that is, the data received by the system but not yet replicated to other node(s). The receiver will be started on a different node and it will continue to receive data.</li>
</ol>
<p>Since all data is modeled as RDDs with their lineage of deterministic operations, any recomputation always leads to the same result. As a result, all DStream transformations are guaranteed to have <em>exactly-once</em> semantics. That is, the final transformed result will be same even if there were was a worker node failure. However, output operations (like <code>foreachRDD</code>) have <em>at-least once</em> semantics, that is, the transformed data may get written to an external entity more than once in the event of a worker failure. While this is acceptable for saving to HDFS using the <code>saveAs*Files</code> operations (as the file will simply get over-written by the same data), additional transactions-like mechanisms may be necessary to achieve exactly-once semantics for output operations.</p>
<p><strong><u>Failure of the Driver Node</u></strong></p>
<p><u>对于Driver Node failure ，Spark是没有做任何处理的，job会失败<br />
而对于SparkStreaming而言，这样是无法接受的，因为流数据你无法重新读出的，对于流处理必须要保证24/7<br />
所以这里做的更多，会定期把DStreams的metadata chechpoint到HDFS上，这样当Driver Node failure，被restart后，可以冲checkpoint文件中把状态恢复过来，继续执行<br />
但是当前对于以network作为input source的情况下，数据还是会丢失，由于driver node的fail会导致sourcedata丢失，虽然你metadata是checkpoint了</u></p>
<p>To allows a streaming application to operate 24/7, Spark Streaming allows a streaming computation to be resumed even after the failure of the driver node. Spark Streaming periodically writes the metadata information of the DStreams setup through the <code>StreamingContext</code> to a HDFS directory (can be any Hadoop-compatible filesystem). This periodic <em>checkpointing</em>can be enabled by setting a the checkpoint directory using <code>ssc.checkpoint(&lt;checkpoint directory&gt;)</code> as described <a href="http://spark.incubator.apache.org/docs/latest/streaming-programming-guide.html#rdd-checkpointing" rel="external nofollow noreferrer">earlier</a>. On failure of the driver node, the lost <code>StreamingContext</code> can be recovered from this information, and restarted.</p>
<p>To allow a Spark Streaming program to be recoverable, it must be written in a way such that it has the following behavior:</p>
<ol>
<li>When the program is being started for the first time, it will create a new StreamingContext, set up all the streams and then call start().</li>
<li>When the program is being restarted after failure, it will re-create a StreamingContext from the checkpoint data in the checkpoint directory.</li>
</ol>

<pre>// Function to create and setup a new StreamingContext
def functionToCreateContext(): StreamingContext = {
    val ssc = new StreamingContext(...)   // new context
    val lines = ssc.socketTextStream(...) // create DStreams
    ...
    ssc.checkpoint(checkpointDirectory)   // set checkpoint directory
    ssc
}

// Get StreaminContext from checkpoint data or create a new one
val context = StreamingContext.getOrCreate(checkpointDirectory, functionToCreateContext _)

// Do additional setup on context that needs to be done,
// irrespective of whether it is being started or restarted
context. ...

// Start the context
context.start()
context.awaitTermination()</pre>
<p>If the <code>checkpointDirectory</code> exists, then the context will be recreated from the checkpoint data. If the directory does not exist (i.e., running for the first time), then the function <code>functionToCreateContext</code> will be called to create a new context and set up the DStreams. See the Scala example <a href="https://github.com/apache/incubator-spark/tree/master/examples/src/main/scala/org/apache/spark/streaming/examples/RecoverableNetworkWordCount.scala" rel="external nofollow noreferrer">RecoverableNetworkWordCount</a>. This example appends the word counts of network data into a file.You can also explicitly create a <code>StreamingContext</code> from the checkpoint data and start the computation by using <code>new StreamingContext(checkpointDirectory)</code>.</p>
<p><strong>Note</strong>: If Spark Streaming and/or the Spark Streaming program is recompiled, you <em>must</em> create a new <code>StreamingContext</code> or<code>JavaStreamingContext</code>, not recreate from checkpoint data. This is because trying to load a context from checkpoint data may fail if the data was generated before recompilation of the classes. So, if you are using <code>getOrCreate</code>, then make sure that the checkpoint directory is explicitly deleted every time recompiled code needs to be launched.</p>
<p>This failure recovery can be done automatically using Spark’s <a href="http://spark.incubator.apache.org/docs/latest/spark-standalone.html" rel="external nofollow noreferrer">standalone cluster mode</a>, which allows any Spark application’s driver to be as well as, ensures automatic restart of the driver on failure (see <a href="http://spark.incubator.apache.org/docs/latest/spark-standalone.html#launching-applications-inside-the-cluster" rel="external nofollow noreferrer">supervise mode</a>). This can be tested locally by launching the above example using the supervise mode in a local standalone cluster and killing the java process running the driver (will be shown as <em>DriverWrapper</em> when <code>jps</code> is run to show all active Java processes). The driver should be automatically restarted, and the word counts will cont</p>
<p>For other deployment environments like Mesos and Yarn, you have to restart the driver through other mechanisms.</p>
<p><strong><u>Recovery Semantics</u></strong></p>
<p>There are two different failure behaviors based on which input sources are used.</p>
<ol>
<li><em>Using HDFS files as input source</em> - Since the data is reliably stored on HDFS, all data can re-computed and therefore no data will be lost due to any failure.</li>
<li><em>Using any input source that receives data through a network</em> - The received input data is replicated in memory to multiple nodes. Since, all the data in the Spark worker’s memory is lost when the Spark driver fails, the past input data will not be accessible and driver recovers. Hence, if stateful and window-based operations are used (like<code>updateStateByKey</code>, <code>window</code>, <code>countByValueAndWindow</code>, etc.), then the intermediate state will not be recovered completely.</li>
</ol>
<p>In future releases, we will support full recoverability for all input sources. Note that for non-stateful transformations like <code>map</code>,<code>count</code>, and <code>reduceByKey</code>, with <em>all</em> input streams, the system, upon restarting, will continue to receive and process new data</p>
<p>本文章摘自博客园，原文发布日期： 2014-02-21</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-25 09:37:03</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/input/" title="input">input</a>, <a href="https://www.iamivan.net/tag/source/" title="source">source</a>, <a href="https://www.iamivan.net/tag/spark/" title="spark">spark</a>, <a href="https://www.iamivan.net/tag/processing/" title="Processing">Processing</a>, <a href="https://www.iamivan.net/tag/stream/" title="stream">stream</a>, <a href="https://www.iamivan.net/tag/metadata/" title="metadata">metadata</a>, <a href="https://www.iamivan.net/tag/guide/" title="guide">guide</a>, <a href="https://www.iamivan.net/tag/cluster/" title="cluster">cluster</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Spark Streaming Programming Guide的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7Z0E4p.html" rel="bookmark">Structured Streaming Programming Guide</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				https://spark.apache.org/docs/latest/structured-streaming-programming-guide.html http://www.slideshare.net/databricks/a-deep-dive-into-structured-streaming   Structured Streaming is a scalable and fault-tolerant stream processing engine built on the			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrW40xp.html" rel="bookmark">《Spark官方文档》Spark Streaming编程指南（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark Streaming编程指南 概览   Spark Streaming是对核心Spark API的一个扩展,它能够实现对实时数据流的流式处理,并具有很好的可扩展性.高吞吐量和容错性.Spark Streaming支持从多种数据源提取数据,如:Kafka.Flume.Twitter.ZeroMQ.Kinesis以及TCP套接字,并且可以提供一些高级API来表达复杂的处理算法,如:map.reduce.join和window等.最后,Spark Streaming支持将处理完的数据推送到文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkWA7b.html" rel="bookmark">《Spark官方文档》Spark Streaming编程指南（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				累加器和广播变量 首先需要注意的是,累加器(Accumulators)和广播变量(Broadcast variables)是无法从Spark Streaming的检查点中恢复回来的.所以如果你开启了检查点功能,并同时在使用累加器和广播变量,那么你最好是使用懒惰实例化的单例模式,因为这样累加器和广播变量才能在驱动器(driver)故障恢复后重新实例化.代码示例如下: Scala Java Python object WordBlacklist { @volatile private var ins			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MA615Kp.html" rel="bookmark">Spark Streaming 实现思路与模块概述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark Streaming 实现思路与模块概述 [酷玩 Spark] Spark Streaming 源码解析系列 ,返回目录请 猛戳这里 「腾讯·广点通」技术团队荣誉出品 本文内容适用范围: 2016.01.04 update, Spark 1.6 全系列 √ (1.6.0) 2015.11.09 update, Spark 1.5 全系列 √ (1.5.0, 1.5.1, 1.5.2) 2015.07.15 update, Spark 1.4 全系列 √ (1.4.0, 1.4.1) 2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6eW1Ab.html" rel="bookmark">Kafka&plus;Spark Streaming&plus;Redis实时计算整合实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于Spark通用计算平台,可以很好地扩展各种计算类型的应用,尤其是Spark提供了内建的计算库支持,像Spark Streaming.Spark SQL.MLlib.GraphX,这些内建库都提供了高级抽象,可以用非常简洁的代码实现复杂的计算逻辑.这也得益于Scala编程语言的简洁性.这里,我们基于1.3.0版本的Spark搭建了计算平台,实现基于Spark Streaming的实时计算. 我们的应用场景是分析用户使用手机App的行为,描述如下所示: 手机客户端会收集用户的行为事件(我们以点击			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5onR7b.html" rel="bookmark">Spark Streaming和Flink的Word Count对比</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				准备: nccat for windows/linux 都可以 通过 TCP 套接字连接,从流数据中创建了一个 Spark DStream/ Flink DataSream, 然后进行处理, 时间窗口大小为10s 因为 示例需要, 所以 需要下载一个netcat, 来构造流的输入. 代码: spark streaming package cn.kee.spark; public final class JavaNetworkWordCount { private static final Pat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2PYJ3p.html" rel="bookmark">Spark Streaming原理简析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				执行流程 数据的接收 StreamingContext实例化的时候,需要传入一个SparkContext,然后指定要连接的spark matser url,即连接一个spark engine,用于获得executor. 实例化之后,首先,要指定一个接收数据的方式,如 val lines = ssc.socketTextStream(&quot;localhost&quot;, 9999) 这样从socket接收文本数据.这个步骤返回的是一个ReceiverInputDStream的实现,内含Receive			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWywWp.html" rel="bookmark">Spark Streaming Crash 如何保证Exactly Once Semantics</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 其实这次写Spark Streaming相关的内容,主要是解决在其使用过程中大家真正关心的一些问题.我觉得应该有两块: 数据接收.我在用的过程中确实产生了问题. 应用的可靠性.因为SS是7*24小时运行的问题,我想知道如果它Crash了,会不会丢数据. 第一个问题在之前的三篇文章已经有所阐述: Spark Streaming 数据产生与导入相关的内存分析 Spark Streaming 数据接收优化 Spark Streaming Direct Approach (No Receivers			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqA18GM.html" rel="bookmark">Spark Streaming Dynamic Resource Allocation 文档&lpar;非官方特性&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				必要配置 通过下面参数开启DRA spark.streaming.dynamicAllocation.enabled=true 设置最大最小的Executor 数目: spark.streaming.dynamicAllocation.minExecutors=0 spark.streaming.dynamicAllocation.maxExecutors=50 可选配置 这些参数可以不用配置,都已经提供了一个较为合理的默认值 开启日志: spark.streaming.dynamicAlloc			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPPkvp.html" rel="bookmark" class="title">新手学JAVA（三）----StringBuilder类</a>
					<div>
						   上一篇文章新手学JAVA(二)----String类与StringBuffer类的区别中了解到,String的值是不可变的,这就导致 每次对String的操作都会生成新的String对象,不仅效 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGEyvM.html" rel="bookmark" class="title">PS为美女照片调出艺术暗黄色调教程</a>
					<div>
						效果 原图 方法很简单,没有细做,欢迎指正. 1.打开复制一层,转LAB.应用图象(数字如图1) 2.转RGB模式,可选颜色(数字如图2) 3.盖印.,磨皮锐化处理,完工.(这里我修了眼睛) 下面是步 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE8rLz.html" rel="bookmark" class="title">Mysql的Root密码遗忘的解决办法</a>
					<div>
						Mysql是一个多线程的,结构化查询语言(SQL)数据库服务器.SQL 在世界上是最流行的数据库语言.MySQL 的执行性能非常高,运行速度非常快,并非常容易使用.是一个非常捧的数据库. 下载地址:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7Lmqb.html" rel="bookmark" class="title">为freetextbox1&period;6&period;5上传图片加上水印</a>
					<div>
						上传|上传图片 Graphics的DrawImage方法,定义了多种原型,可以在制定位置绘制指定Image对象.利用此方法可以在图片对象上再绘制一个水印图片.结合FreeTextBox方便的图片上传功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bal76Jz.html" rel="bookmark" class="title">Iptables &plus; L7 &plus;squid 实现防火墙功能</a>
					<div>
						Iptables + L7 +squid 实现防火墙功能 为iptables增加layer7补丁(Linux2.6.25内核) #################################### ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDA8OWb.html" rel="bookmark" class="title">搜狗输入法怎样使用简拼</a>
					<div>
						搜狗输入法现在支持的是声母简拼和声母的首字母简拼.例如:你想输入&quot;张靓颖&quot;,你只要输入&quot;zhly&quot;或者&quot;zly&quot;都可以输入&quot;张靓颖 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAOAXb.html" rel="bookmark" class="title">Word2007打印省钱技巧</a>
					<div>
						我们经常遇到这样的情况,最后一页只有寥寥几行甚至几个字,却仍需要占用一整页的空间.打印时不但浪费纸张,而且版面也不好看.怎么样才能把多余的这部分文字匀入前面页面呢? 在Word2007&quot;页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNRkDb.html" rel="bookmark" class="title">火狐浏览器39新功能有哪些</a>
					<div>
						Firefox火狐浏览器39更新内容: 火狐浏览器Firefox版本号在不断提升.38.0版本刚发布不到一个月,39.0正式版又发布了. 一些细节功能增加与完善,还修复了部分问题. Mac用户不妨来试 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1RGN8p.html" rel="bookmark" class="title">360安全浏览器-保护上网安全</a>
					<div>
						  以IE为内核可以获得最大的网页兼容性,但是IE内核也是遭到研究和攻击最多的内核.经常有各种网页采用恶意脚本试图获取不正当利益.这方面360安全浏览器做了很多安全防范工作,可以有效保证您的上网安全. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3KAOM.html" rel="bookmark" class="title">Excel2016的预测工作表forecast该怎么使用&quest;</a>
					<div>
						  Excel 2016 有一项功能叫&quot;预测工作表&quot;,可以从历史数据分析出事物发展的未来趋势,并以图表的形式展现出来,对于直观地观察事物发展方向或发展趋势,有一定帮助. 注:本经验 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z424lNM.html" rel="bookmark" class="title">Photoshop制作重影效果的3D电影海报</a>
					<div>
						电影海报修改前后效果图,拿3D眼镜来瞧瞧哟:) 第一步: 运行Photoshop,然后(ctrl + o) 打开海报图片. 第二步: 为了让图片看起来更好和更有趣, 我们先来做些修改.先运行软件eye ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArjkAp.html" rel="bookmark" class="title">12306登录名忘了怎么办？</a>
					<div>
						  按12306网上订票登录页面&quot;忘记用户名/密码&quot;链接找回,如果实在无法找回用户名或密码,你可以按12306网上订票常用问题里的方法提交申请注销以前的账号,然后重新注册,你也可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEW9Y3p.html" rel="bookmark" class="title">Macbook Pro笔记本中的光盘拿不出来了怎么办？</a>
					<div>
						  Macbook Pro以其精湛的工艺和时尚的外形,成为很多人向往的笔记本.但是再好的产品,也有出问题的时候,这不,当光盘卡在光驱里出不来时,抓瞎了吧?难道真要拆机不成?NO!且住,这事有商量. 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3BXyp.html" rel="bookmark" class="title">自己写的一段解决ARRAYLIST批量接口调用以后乱序的代码</a>
					<div>
						import java.util.ArrayList; import java.util.Collections; import java.util.HashMap; import java.util ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDW4RBp.html" rel="bookmark" class="title">项目从mysql迁移到oracle报错</a>
					<div>
						问题描述 项目从mysql迁移到oracle报错 本来没有一点错误,迁移之后出现了很多,不知道哪位大神见过下面的问题: 17:23:54,967 ERROR BasicPropertyAccessor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0wqkM.html" rel="bookmark" class="title">编程c语言-CC语言中的main函数中的参数</a>
					<div>
						问题描述 CC语言中的main函数中的参数 就是int argc char *argv[ ] 这个是什么意思,怎么样进行传参的,求大神指点迷津... 解决方案 C编译器允许main()函数没有参数,或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWqjvz.html" rel="bookmark" class="title">c&plus;&plus; SYN 网络编程遇到问题 小白求教</a>
					<div>
						问题描述 c++ SYN 网络编程遇到问题 小白求教 以下是代码,运行无错误,但是用wireshark 抓不到发出的SYN包,求高手解释原因.. #include &lt;stdlib.h&gt; # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4n3Jz.html" rel="bookmark" class="title">利用js cookie记录用户访问次数</a>
					<div>
						录的数目你访问网页时,并显示取决于次数各种消息 &lt;SCRIPT&gt;  // for viewing source code  &lt;!---Activate Cloaking Device ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Y0Zxz.html" rel="bookmark" class="title">c&plus;&plus;语法问题-C&plus;&plus; 缩写符号问题简洁写法的错误</a>
					<div>
						问题描述 C++ 缩写符号问题简洁写法的错误 编写程序由从标准输入设备读入的元素数据建立一个int 型vector 对象,然后 动态创建一个与该vector 对象大小一致的数组,把vector 对象的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nmn7z.html" rel="bookmark" class="title">个人网站模板</a>
					<div>
						个人网站模板已经建好了,在这几天的加班加点下我自己的网站已经有了雏形.我也想想很多朋友都想拥有自己的网站,但是都有畏惧心理,都想我不是计算机专业的学生怎么可能写得来网页,开始我也是这种心理,今年趁着过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV77GQb.html" rel="bookmark" class="title">简单掌握iOS应用开发中sandbox沙盒的使用&lowbar;IOS</a>
					<div>
						一.iOS沙盒机制 iOS的应用只能访问为该应用创建的区域,不可访问其他区域,应用的其他非代码文件都存在此目录下,包括图片,属性文件plist,bundle,nib文件等,这块区域称之为沙盒(sand ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKv15M.html" rel="bookmark" class="title">求教：MVC中引用js动态创建页面无法获取图片。</a>
					<div>
						问题描述 MVC项目中使用了一个第三方UI组件,在视图中引用该UI的js文件,调用js动态创建页面,其中引用的图片资源无法显示.但是在html文件中使用该js文件,可以正常显示.用firebug调试, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGra56p.html" rel="bookmark" class="title">祖传CMOS走出家门&comma;佳能将在传感器供应圈中决战索尼</a>
					<div>
						大家都知道,索尼现在是相机圈中处于龙头地位的 CMOS 传感器供应商. 飞思 XF 100MP 用 1 亿像素的传感器也是出自索尼之手 包括尼康.富士.宾得.飞思 PHASEONE 内的数家相机厂商, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx2YY0z.html" rel="bookmark" class="title">非静态内部类可能导致的内存泄漏及其优化</a>
					<div>
						package cc.cc; import android.os.Bundle; import android.app.Activity; /** * Demo描述: * 非静态内部类可能导致的内存泄 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn46yWb.html" rel="bookmark" class="title">Hyper-v的第2代虚拟机Windows Server 2012 R2</a>
					<div>
						随着Windows Server 2012 R2的发布,微软的Hyper-v进行了更深层次的更新,产生了新一代虚拟机,微软管它叫第2代虚拟机.那什么是第1代虚拟机?Windows Server 200 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAkXqp.html" rel="bookmark" class="title">挂钩理赔次数 告别&OpenCurlyDoubleQuote;五毛&rdquo;一口价</a>
					<div>
						挂钩理赔次数 告别&quot;五毛&quot;一口价 网购退货运费保险涨价 近年关,打年货,网购又开始&quot;火&quot;起来.昨日,眼尖的市民告诉记者,一直宣称&quot;保费低.赔付高&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEJv26M.html" rel="bookmark" class="title">左右为难的服务费标准</a>
					<div>
						摘要: 原本于3月1日起在合肥实施的1.7元/度的充电服务费标准终因新能源车企和消费者的质疑而被推迟实施.近日,有消息称,在合肥物价局和市科委.车企以及充电设施运营公司的共同协商 原本于3月1日起在合 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjEdvnz.html" rel="bookmark" class="title">php中的boolean&lpar;布尔&rpar;类型详解&lowbar;php实例</a>
					<div>
						当转换为 boolean 时,以下值被认为是 FALSE: the 布尔值 FALSE 自身 the 整型值 0 (零) the 浮点型值 0.0 (零) 空 字符串, 以及 字符串 &quot;0& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDj4rXM.html" rel="bookmark" class="title">柳传志抱怨去台湾开研讨会签证太难</a>
					<div>
						中广网北京3月11日消息 (记者夏恩博) 3月11日上午,在梅地亚中心的十一届全国人大三次会议新闻中心,联想控股有限公司总裁柳传志回答台湾媒体记者的关于去台湾投资的问题后幽默地说:我有一个抱怨,我们邀 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLJxWWb.html" rel="bookmark" class="title">冰箱市场相比今年上半年呈现出较为明显的回暖趋势</a>
					<div>
						[赛迪网讯]10月10日消息,随着国庆7天长假的到来,冰箱市场相比今年上半年呈现出较为明显的回暖趋势,大容量.无霜的冰箱产品成为了消费者关注的焦点.在近日青岛新闻网开展的一项名为&quot;别说你会用 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.048 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
